/*
  these are various prototypes for external 
  FORTRAN functions


  $Id: fortran_proto.h,v 1.11 2003/03/02 01:38:27 becker Exp becker $

*/
//
// solver related headers of external functions
//
// $Id: fortran_proto.h,v 1.11 2003/03/02 01:38:27 becker Exp becker $
//
#include "numrec_svd_routines.h"

//
// LAPACK fortran style (not C implementation as in sunperf.h)
// 

extern void ilwvd(int *,int *, int *, int * );

extern void dgelss( int *, int *,int *, double *, int *, 
		    double *, int *,  double *,  double *,
		    int *, double *, int *, int * );

extern void sgelss( int *, int *,int *, float *, int *, 
		    float *, int *,  float *,  float *,
		    int *, float *, int *, int * );

extern void dgelsd( int *, int *,int *, double *, int *, 
		    double *, int *,  double *,  double *,
		    int *, double *, int *, int *,int * );

extern void sgelsd( int *, int *,int *, float *, int *, 
		    float *, int *,  float *,  float *,
		    int *, float *, int *, int *,int * );

extern void dgesvd(char *, char *, int *, int *, 
		    double *, int *, double *, double *, int *, 
		    double *, int *, double *, int *, int *);

extern void sgesvd(char *, char *, int *, int *, 
		   float *, int *, float *, float *, int *, 
		   float *, int *, float *, int *, int *);

extern void dgesv(int *, int *, double *, int *, int *, double *, 
		  int *, int *);

extern void sgesv(int *, int *, float *, int *, int *, float *, 
		  int *, int *);



extern void law_nnls(A_MATRIX_PREC *,int *,int *, int *,
		     A_MATRIX_PREC *,A_MATRIX_PREC *,
		     A_MATRIX_PREC *,A_MATRIX_PREC *,
		     A_MATRIX_PREC *,int *, int *);

/*

  OKADA routines

 */
extern void dc3d(COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,COMP_PRECISION*,
		 COMP_PRECISION*,int*);
extern void dc3d0(COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  COMP_PRECISION*,COMP_PRECISION*,
		  int*);

extern void palett(int *, float *, float *);

// eispack
extern void  rs(int *, int *, double *,double *, int *, 
		double *, double *,double *, int *);

extern void  s_rs(int *, int *, float *,float *, int *, 
		  float *, float *,float *, int *);

/* crouch and starfield coeff modified */
extern void tdd_coeff(COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,int *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      COMP_PRECISION *,COMP_PRECISION *,
		      int *);

/*

################################################################################
#                                                                              #
#  interact: model fault interactions using dislocations in an elastic         #
#            medium                                                            #
#	                                                                       #
#    Copyright (C) Thorsten W. Becker 2000 - 2002                              #
#                                                                              #
#    Unteract uses dc3d.f as provided by Y. Okada as in Okada (BSSA, 1992) and #
#    linear algebra routines from SLATEC, LAPACK, and EISPACK.                 #
#    Might contain material copyrighted by others (e.g. Numerical Recipes etc) #
#                                                                              #
#  If you use interact in real work, a citation to use would be:               #
#                                                                              #
#  @Article{becker02c,                                                         #
#    author = 	 {Becker, T. W. and Schott, B.},                               #
#    title = 	 {On boundary-element models of elastic fault interaction      #
#                  (abstract)},                                                # 
#    journal = 	 {EOS Trans. AGU},                                             #
#    year = 	 2002,                                                         #
#    volume =	 83,                                                           #
#    number =	 47,                                                           #
#    pages =	 {NG62A-0925}                                                  #
#  }                                                                           #
#                                                                              #
#                                                                              #
#    This program is free software; you can redistribute it and/or modify      #
#    it under the terms of the GNU General Public License as published by      #
#    the Free Software Foundation; either version 2 of the License, or         #
#    (at your option) any later version.                                       #
#                                                                              #
#    This program is distributed in the hope that it will be useful,           #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#    GNU General Public License for more details.                              #
#                                                                              #
#    In addition, we strongly suggest that iGMT users comply with the goals    #
#    as expressed in the Student Pugwash Pledge (www.spusa.org/pugwash/).      #
#                                                                              #
#    You should have received a copy of the GNU General Public License         #
#    along with this program; see the file COPYING.  If not, write to          #
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,          #
#    Boston, MA 02111-1307, USA.                                               #
#                                                                              #
################################################################################

*/

