/* 

   programming conventions and macros
   $Id: macros.h,v 1.22 2003/07/21 22:37:02 becker Exp $

*/
#define TRUE 1
#define FALSE 0

#define SQUARE(a) ((a)*(a))
#ifndef MIN
 #define MIN(x, y) (((x)<(y))?(x):(y))
#endif
#ifndef MAX
 #define MAX(x, y) (((x)>(y))?(x):(y))
#endif

#define INVERSE_LN_TWO  1.44269504088896341
#define log2(x)         (log(x) * INVERSE_LN_TWO)


#define TOGV(x) (((x==FALSE)?(TRUE):(FALSE)))
#define MEMERROR(x) {fprintf(stderr,"%s: memory allocation error\nexiting now.\n",x);exit(-1);}
#define READ_ERROR(x) {fprintf(stderr,"read error file \"%s\", exiting\n",x);exit(-1);}
/* 
   real constants 
*/
#define STRLEN 200
#define PI 3.14159265358979324
#define PIHALF 1.57079632679489661
#define TWOPI 6.28318530717958647
#define DEG2RAD 0.0174532925199432958
#define RAD2DEG 57.2957795130823
#define PIOVERONEEIGHTY DEG2RAD
#define ONEEIGHTYOVERPI  RAD2DEG

//
// the medium structure has a NaN field which will be 
// initialized as sqrt(-1). the nan macro is only used if 
// medium is not passed to subroutines
//
// WARNING: THIS (WHICH SHOULD BE BETTER)
// DID NOT WORK ON IRIX WITH 
// -Ofast: #define NaN (1./0.-1./0.)
//
#define NaN (1.0/0.0)


#define ONE_MEGABYTE 1048576.0


// derived functions

#define RAD2DEGF(x) ((x)*RAD2DEG)
#define DEG2RADF(x) ((x)*DEG2RAD)

// numerical recipes
#define NUMREC_SWAP(a,b) {swap=(a);(a)=(b);(b)=swap;}
#define NUMREC_ISWAP(a,b) {itemp=(a);(a)=(b);(b)=itemp;}


#define RADIUS_EARTH 6371.0 // radius of earth in km

/*

################################################################################
#                                                                              #
#  interact: model fault interactions using dislocations in an elastic         #
#            medium                                                            #
#	                                                                       #
#    Copyright (C) Thorsten W. Becker 2000 - 2002                              #
#                                                                              #
#    Unteract uses dc3d.f as provided by Y. Okada as in Okada (BSSA, 1992) and #
#    linear algebra routines from SLATEC, LAPACK, and EISPACK.                 #
#    Might contain material copyrighted by others (e.g. Numerical Recipes etc) #
#                                                                              #
#  If you use interact in real work, a citation to use would be:               #
#                                                                              #
#  @Article{becker02c,                                                         #
#    author = 	 {Becker, T. W. and Schott, B.},                               #
#    title = 	 {On boundary-element models of elastic fault interaction      #
#                  (abstract)},                                                # 
#    journal = 	 {EOS Trans. AGU},                                             #
#    year = 	 2002,                                                         #
#    volume =	 83,                                                           #
#    number =	 47,                                                           #
#    pages =	 {NG62A-0925}                                                  #
#  }                                                                           #
#                                                                              #
#                                                                              #
#    This program is free software; you can redistribute it and/or modify      #
#    it under the terms of the GNU General Public License as published by      #
#    the Free Software Foundation; either version 2 of the License, or         #
#    (at your option) any later version.                                       #
#                                                                              #
#    This program is distributed in the hope that it will be useful,           #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#    GNU General Public License for more details.                              #
#                                                                              #
#    In addition, we strongly suggest that iGMT users comply with the goals    #
#    as expressed in the Student Pugwash Pledge (www.spusa.org/pugwash/).      #
#                                                                              #
#    You should have received a copy of the GNU General Public License         #
#    along with this program; see the file COPYING.  If not, write to          #
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,          #
#    Boston, MA 02111-1307, USA.                                               #
#                                                                              #
################################################################################

*/

