#define COMP_PRECISION double 
#define C_PREC real*8

#define I_MATRIX_PREC double
#define A_MATRIX_PREC double
#define AM_PREC real*8

#define EPS_COMP_PREC 7.0e-15
#define EPS_AMAT_PREC 7.0e-15
#define EPS_DC3D_PREC 7.0D-15

#define ONE_CP_FORMAT "%lf"
#define ONE_IP_FORMAT "%lf"
#define TWO_CP_FORMAT "%lf %lf"
#define TWO_IP_FORMAT "%lf %lf"
#define THREE_CP_FORMAT "%lf %lf %lf"
#define SIX_CP_FORMAT "%lf %lf %lf %lf %lf %lf"
#define NINE_CP_FORMAT "%lf %lf %lf %lf %lf %lf %lf %lf %lf"
#define TWELVE_CP_FORMAT "%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf"
#define FIFTEEN_CP_FORMAT "%lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf %lf"
#define PATCH_CP_FORMAT "%lf %lf %lf %f %f %lf %lf %i"
#define RS_CP_FORMAT "%lf %lf %lf %f %lf %lf %i"
#define FIELD_CP_FORMAT "%lf %lf %i %lf %lf %i %lf %lf %i"
#define IIF_CP_FORMAT "%i %i %lf"
#define IF_CP_FORMAT "%i %lf"

#define EISPACK_RS rs_

/*

################################################################################
#                                                                              #
#  interact: model fault interactions using dislocations in an elastic         #
#            medium                                                            #
#	                                                                       #
#    Copyright (C) Thorsten W. Becker 2000 - 2002                              #
#                                                                              #
#    Unteract uses dc3d.f as provided by Y. Okada as in Okada (BSSA, 1992) and #
#    linear algebra routines from SLATEC, LAPACK, and EISPACK.                 #
#    Might contain material copyrighted by others (e.g. Numerical Recipes etc) #
#                                                                              #
#  If you use interact in real work, a citation to use would be:               #
#                                                                              #
#  @Article{becker02c,                                                         #
#    author = 	 {Becker, T. W. and Schott, B.},                               #
#    title = 	 {On boundary-element models of elastic fault interaction      #
#                  (abstract)},                                                # 
#    journal = 	 {EOS Trans. AGU},                                             #
#    year = 	 2002,                                                         #
#    volume =	 83,                                                           #
#    number =	 47,                                                           #
#    pages =	 {NG62A-0925}                                                  #
#  }                                                                           #
#                                                                              #
#                                                                              #
#    This program is free software; you can redistribute it and/or modify      #
#    it under the terms of the GNU General Public License as published by      #
#    the Free Software Foundation; either version 2 of the License, or         #
#    (at your option) any later version.                                       #
#                                                                              #
#    This program is distributed in the hope that it will be useful,           #
#    but WITHOUT ANY WARRANTY; without even the implied warranty of            #
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             #
#    GNU General Public License for more details.                              #
#                                                                              #
#    In addition, we strongly suggest that iGMT users comply with the goals    #
#    as expressed in the Student Pugwash Pledge (www.spusa.org/pugwash/).      #
#                                                                              #
#    You should have received a copy of the GNU General Public License         #
#    along with this program; see the file COPYING.  If not, write to          #
#    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,          #
#    Boston, MA 02111-1307, USA.                                               #
#                                                                              #
################################################################################

*/

